'use strict';

var __metamagical_withMeta = function metamagical_withMeta(object, meta) {
  var parent = Object.getPrototypeOf(object);var oldMeta = object[Symbol.for('@@meta:magical')] || {};if (parent && parent[Symbol.for('@@meta:magical')] === oldMeta) {
    oldMeta = {};
  }Object.keys(meta).forEach(function (key) {
    if (/^~/.test(key)) {
      oldMeta[key.slice(1)] = meta[key];
    } else {
      oldMeta[key] = meta[key];
    }
  });object[Symbol.for('@@meta:magical')] = oldMeta;return object;
},
    _metamagical_withMet;

//---------------------------------------------------------------------
//
// This source file is part of the Meta:Magical project.
//
// See LICENCE for licence information.
// See CONTRIBUTORS for the list of contributors to the project.
//
//---------------------------------------------------------------------

/*~
 * Assertions used by other modules.
 *
 * ---
 * name        : module assertions
 * module      : metamagical-interface/lib/assertions
 * isModule    : true
 * category    : Assertions
 * portability : portable
 * platforms:
 *   - ECMAScript 3
 */
module.exports = __metamagical_withMeta((_metamagical_withMet = {
  assertObject: function assertObject(value) {
    if (Object(value) !== value) {
      var kind = value === null ? 'null' : value === undefined ? 'undefined' : /* otherwise */'a primitive value (' + JSON.stringify(value) + ')';

      throw new TypeError('Meta:Magical can only associate meta-data with objects, but you\'re trying to use ' + kind);
    }
  }
}, __metamagical_withMeta(_metamagical_withMet['assertObject'], {
  'name': 'assertObject',
  'source': 'assertObject(value) {\n    if (Object(value) !== value) {\n      const kind = value === null      ?  \'null\'\n      :            value === undefined ?  \'undefined\'\n      :            /* otherwise */        `a primitive value (${JSON.stringify(value)})`;\n\n      throw new TypeError(`Meta:Magical can only associate meta-data with objects, but you\'re trying to use ${kind}`);\n    }\n  }',
  'signature': 'assertObject(value)',
  'location': {
    'filename': 'packages/interface/src/assertions.js',
    'start': {
      'line': 22,
      'column': 17
    },
    'end': {
      'line': 45,
      'column': 1
    }
  },
  'module': 'metamagical-interface/src/assertions',
  'homepage': 'https://github.com/origamitower/metamagical#readme',
  'licence': 'MIT',
  'authors': ['Quildreen Motta <queen@robotlolita.me>'],
  'repository': 'git://github.com/origamitower/metamagical.git',
  'npmPackage': 'metamagical-interface',
  'copyright': '(c) 2016 Quildreen Motta',
  'maintainers': ['Quildreen Motta <queen@robotlolita.me> (http://robotlolita.me/)'],
  'category': 'Assertions',
  'stability': 'stable',
  'throws': {
    'TypeError': 'when the value isn\'t an object.'
  },
  'type': '(Any) => None :: throws TypeError\n \n',
  'documentation': '\nMakes sure that `value` is an object.\n'
}), _metamagical_withMet), {
  'name': 'module assertions',
  'source': '{\n  /*~\n   * Makes sure that `value` is an object.\n   *\n   * ---\n   * category  : Assertions\n   * stability : stable\n   *\n   * throws:\n   *   TypeError: when the value isn\'t an object.\n   *\n   * type: |\n   *   (Any) => None :: throws TypeError\n   */\n  assertObject(value) {\n    if (Object(value) !== value) {\n      const kind = value === null      ?  \'null\'\n      :            value === undefined ?  \'undefined\'\n      :            /* otherwise */        `a primitive value (${JSON.stringify(value)})`;\n\n      throw new TypeError(`Meta:Magical can only associate meta-data with objects, but you\'re trying to use ${kind}`);\n    }\n  }\n}',
  'location': {
    'filename': 'packages/interface/src/assertions.js',
    'start': {
      'line': 22,
      'column': 0
    },
    'end': {
      'line': 45,
      'column': 2
    }
  },
  'module': 'metamagical-interface/lib/assertions',
  'homepage': 'https://github.com/origamitower/metamagical#readme',
  'licence': 'MIT',
  'authors': ['Quildreen Motta <queen@robotlolita.me>'],
  'repository': 'git://github.com/origamitower/metamagical.git',
  'npmPackage': 'metamagical-interface',
  'copyright': '(c) 2016 Quildreen Motta',
  'maintainers': ['Quildreen Motta <queen@robotlolita.me> (http://robotlolita.me/)'],
  'isModule': true,
  'category': 'Assertions',
  'portability': 'portable',
  'platforms': ['ECMAScript 3'],
  'documentation': '\nAssertions used by other modules.\n'
});