'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var __metamagical_withMeta = function metamagical_withMeta(object, meta) {
  var parent = Object.getPrototypeOf(object);var oldMeta = object[Symbol.for('@@meta:magical')] || {};if (parent && parent[Symbol.for('@@meta:magical')] === oldMeta) {
    oldMeta = {};
  }Object.keys(meta).forEach(function (key) {
    if (/^~/.test(key)) {
      oldMeta[key.slice(1)] = meta[key];
    } else {
      oldMeta[key] = meta[key];
    }
  });object[Symbol.for('@@meta:magical')] = oldMeta;return object;
},
    _Refinable$refine;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

//---------------------------------------------------------------------
//
// This source file is part of the Meta:Magical project.
//
// See LICENCE for licence information.
// See CONTRIBUTORS for the list of contributors to the project.
//
//---------------------------------------------------------------------

// --[ Shared State ]--------------------------------------------------
var metadata = new WeakMap();
var metaSymbol = Symbol.for('@@meta:magical');

// --[ Dependencies ]--------------------------------------------------
var Refinable = require('refinable');
var Maybe = require('data.maybe');

var _require = require('./assertions');

var assertObject = _require.assertObject;

var fields = require('./fields');
var Stability = require('./stability');

// --[ Aliases ]-------------------------------------------------------
var symbols = Object.getOwnPropertySymbols;
var propertiesOf = Object.getOwnPropertyNames;
var keys = Object.keys;
var hasProperty = Function.call.bind(Object.prototype.hasOwnProperty);
var prototypeOf = Object.getPrototypeOf;

// --[ Helpers ]-------------------------------------------------------

/*~
 * Returns a getter or setter in an object.
 */
function getGetterSetter(object, name, kind) {
  if (hasProperty(object, name)) {
    var descriptor = descriptorOf(object, name);
    return descriptor[kind] ? Maybe.Just(descriptor[kind]) : /* otherwise */Maybe.Nothing();
  } else {
    return Maybe.Nothing();
  }
}

/*~
 * Retrieves meta-data from an object (either set directly or associated
 * through the global `WeakMap`).
 */

__metamagical_withMeta(getGetterSetter, {
  'name': 'getGetterSetter',
  'source': 'function getGetterSetter(object, name, kind) {\n  if (hasProperty(object, name)) {\n    const descriptor = descriptorOf(object, name);\n    return descriptor[kind] ?  Maybe.Just(descriptor[kind])\n    :      /* otherwise */     Maybe.Nothing();\n  } else {\n    return Maybe.Nothing();\n  }\n}',
  'signature': 'getGetterSetter(object, name, kind)',
  'location': {
    'filename': 'packages/interface/src/index.js',
    'start': {
      'line': 36,
      'column': 0
    },
    'end': {
      'line': 44,
      'column': 1
    }
  },
  'module': 'metamagical-interface/src',
  'homepage': 'https://github.com/origamitower/metamagical#readme',
  'licence': 'MIT',
  'authors': ['Quildreen Motta <queen@robotlolita.me>'],
  'repository': 'git://github.com/origamitower/metamagical.git',
  'npmPackage': 'metamagical-interface',
  'copyright': '(c) 2016 Quildreen Motta',
  'maintainers': ['Quildreen Motta <queen@robotlolita.me> (http://robotlolita.me/)'],
  'documentation': '\nReturns a getter or setter in an object.\n '
});

function getMeta(object) {
  assertObject(object);

  var data = {};
  if (hasOwnSymbol(object, metaSymbol)) {
    Object.assign(data, object[metaSymbol] || {});
  }
  Object.assign(data, metadata.get(object) || {});

  return data;
}

/*~
 * Tests if something is an object.
 */

__metamagical_withMeta(getMeta, {
  'name': 'getMeta',
  'source': 'function getMeta(object) {\n  assertObject(object);\n\n  let data = {};\n  if (hasOwnSymbol(object, metaSymbol)) {\n    Object.assign(data, object[metaSymbol] || {});\n  }\n  Object.assign(data, metadata.get(object) || {});\n\n  return data;\n}',
  'signature': 'getMeta(object)',
  'location': {
    'filename': 'packages/interface/src/index.js',
    'start': {
      'line': 50,
      'column': 0
    },
    'end': {
      'line': 60,
      'column': 1
    }
  },
  'module': 'metamagical-interface/src',
  'homepage': 'https://github.com/origamitower/metamagical#readme',
  'licence': 'MIT',
  'authors': ['Quildreen Motta <queen@robotlolita.me>'],
  'repository': 'git://github.com/origamitower/metamagical.git',
  'npmPackage': 'metamagical-interface',
  'copyright': '(c) 2016 Quildreen Motta',
  'maintainers': ['Quildreen Motta <queen@robotlolita.me> (http://robotlolita.me/)'],
  'documentation': '\nRetrieves meta-data from an object (either set directly or associated\nthrough the global `WeakMap`).\n '
});

function isObject(x) {
  return Object(x) === x;
}

/*~
 * Flattens one level of a list of lists.
 * ---
 * complexity: O(`xss.length`)
 */

__metamagical_withMeta(isObject, {
  'name': 'isObject',
  'source': 'function isObject(x) {\n  return Object(x) === x;\n}',
  'signature': 'isObject(x)',
  'location': {
    'filename': 'packages/interface/src/index.js',
    'start': {
      'line': 66,
      'column': 0
    },
    'end': {
      'line': 68,
      'column': 1
    }
  },
  'module': 'metamagical-interface/src',
  'homepage': 'https://github.com/origamitower/metamagical#readme',
  'licence': 'MIT',
  'authors': ['Quildreen Motta <queen@robotlolita.me>'],
  'repository': 'git://github.com/origamitower/metamagical.git',
  'npmPackage': 'metamagical-interface',
  'copyright': '(c) 2016 Quildreen Motta',
  'maintainers': ['Quildreen Motta <queen@robotlolita.me> (http://robotlolita.me/)'],
  'documentation': '\nTests if something is an object.\n '
});

function flatten(xss) {
  return xss.reduce(function (ys, xs) {
    return ys.concat(xs);
  }, []);
}

/*~
 * Checks if an object has a symbol defined in itself.
 */

__metamagical_withMeta(flatten, {
  'name': 'flatten',
  'source': 'function flatten(xss) {\n  return xss.reduce((ys, xs) => ys.concat(xs), []);\n}',
  'signature': 'flatten(xss)',
  'location': {
    'filename': 'packages/interface/src/index.js',
    'start': {
      'line': 76,
      'column': 0
    },
    'end': {
      'line': 78,
      'column': 1
    }
  },
  'module': 'metamagical-interface/src',
  'homepage': 'https://github.com/origamitower/metamagical#readme',
  'licence': 'MIT',
  'authors': ['Quildreen Motta <queen@robotlolita.me>'],
  'repository': 'git://github.com/origamitower/metamagical.git',
  'npmPackage': 'metamagical-interface',
  'copyright': '(c) 2016 Quildreen Motta',
  'maintainers': ['Quildreen Motta <queen@robotlolita.me> (http://robotlolita.me/)'],
  'complexity': 'O(`xss.length`)',
  'documentation': '\nFlattens one level of a list of lists.'
});

function hasOwnSymbol(object, symbol) {
  return symbols(object).indexOf(symbol) !== -1;
}

/*~
 * Groups values based on the grouping function provided.
 * ---
 * complexity: O(`xs.length`)
 */

__metamagical_withMeta(hasOwnSymbol, {
  'name': 'hasOwnSymbol',
  'source': 'function hasOwnSymbol(object, symbol) {\n  return symbols(object).indexOf(symbol) !== -1;\n}',
  'signature': 'hasOwnSymbol(object, symbol)',
  'location': {
    'filename': 'packages/interface/src/index.js',
    'start': {
      'line': 84,
      'column': 0
    },
    'end': {
      'line': 86,
      'column': 1
    }
  },
  'module': 'metamagical-interface/src',
  'homepage': 'https://github.com/origamitower/metamagical#readme',
  'licence': 'MIT',
  'authors': ['Quildreen Motta <queen@robotlolita.me>'],
  'repository': 'git://github.com/origamitower/metamagical.git',
  'npmPackage': 'metamagical-interface',
  'copyright': '(c) 2016 Quildreen Motta',
  'maintainers': ['Quildreen Motta <queen@robotlolita.me> (http://robotlolita.me/)'],
  'documentation': '\nChecks if an object has a symbol defined in itself.\n '
});

function groupBy(values, groupingFn) {
  var result = new Map();

  values.forEach(function (value) {
    var key = groupingFn(value);
    var values = result.get(key) || [];

    values.push(value);
    result.set(key, values);
  });

  return Array.from(result.entries());
}

/*~
 * Returns the descriptor searching upwards the prototype chain.
 */

__metamagical_withMeta(groupBy, {
  'name': 'groupBy',
  'source': 'function groupBy(values, groupingFn) {\n  let result = new Map();\n\n  values.forEach(value => {\n    const key    = groupingFn(value);\n    const values = result.get(key) || [];\n\n    values.push(value);\n    result.set(key, values);\n  });\n\n  return Array.from(result.entries());\n}',
  'signature': 'groupBy(values, groupingFn)',
  'location': {
    'filename': 'packages/interface/src/index.js',
    'start': {
      'line': 93,
      'column': 0
    },
    'end': {
      'line': 105,
      'column': 1
    }
  },
  'module': 'metamagical-interface/src',
  'homepage': 'https://github.com/origamitower/metamagical#readme',
  'licence': 'MIT',
  'authors': ['Quildreen Motta <queen@robotlolita.me>'],
  'repository': 'git://github.com/origamitower/metamagical.git',
  'npmPackage': 'metamagical-interface',
  'copyright': '(c) 2016 Quildreen Motta',
  'maintainers': ['Quildreen Motta <queen@robotlolita.me> (http://robotlolita.me/)'],
  'complexity': 'O(`xs.length`)',
  'documentation': '\nGroups values based on the grouping function provided.'
});

function descriptorOf(object, name) {
  var descriptor = Object.getOwnPropertyDescriptor(object, name);
  if (descriptor) {
    return descriptor;
  } else {
    var proto = prototypeOf(object);
    if (proto) {
      return descriptorOf(proto, name);
    } else {
      return null;
    }
  }
}

/*~
 * Returns an array of property names in an object.
 * ---
 * complexity: O(number of enumberable properties)
 */

__metamagical_withMeta(descriptorOf, {
  'name': 'descriptorOf',
  'source': 'function descriptorOf(object, name) {\n  const descriptor = Object.getOwnPropertyDescriptor(object, name);\n  if (descriptor) {\n    return descriptor;\n  } else {\n    const proto = prototypeOf(object);\n    if (proto) {\n      return descriptorOf(proto, name);\n    } else {\n      return null;\n    }\n  }\n}',
  'signature': 'descriptorOf(object, name)',
  'location': {
    'filename': 'packages/interface/src/index.js',
    'start': {
      'line': 110,
      'column': 0
    },
    'end': {
      'line': 122,
      'column': 1
    }
  },
  'module': 'metamagical-interface/src',
  'homepage': 'https://github.com/origamitower/metamagical#readme',
  'licence': 'MIT',
  'authors': ['Quildreen Motta <queen@robotlolita.me>'],
  'repository': 'git://github.com/origamitower/metamagical.git',
  'npmPackage': 'metamagical-interface',
  'copyright': '(c) 2016 Quildreen Motta',
  'maintainers': ['Quildreen Motta <queen@robotlolita.me> (http://robotlolita.me/)'],
  'documentation': '\nReturns the descriptor searching upwards the prototype chain.\n '
});

function allPropertiesOf(object) {
  function go(object) {
    var proto = prototypeOf(object);

    return proto ? propertiesOf(object).concat(go(proto)) : /* else */propertiesOf(object);
  }

  return Array.from(new Set(go(object)));
}

/*~
 * Converts an array of property names into an array of Entry.
 * ---
 * complexity: O(properties.length)
 */

__metamagical_withMeta(allPropertiesOf, {
  'name': 'allPropertiesOf',
  'source': 'function allPropertiesOf(object) {\n  function go(object) {\n    const proto = prototypeOf(object);\n\n    return proto       ?  propertiesOf(object).concat(go(proto))\n    :      /* else */     propertiesOf(object);\n  }\n\n  return Array.from(new Set(go(object)));\n}',
  'signature': 'allPropertiesOf(object)',
  'location': {
    'filename': 'packages/interface/src/index.js',
    'start': {
      'line': 129,
      'column': 0
    },
    'end': {
      'line': 138,
      'column': 1
    }
  },
  'module': 'metamagical-interface/src',
  'homepage': 'https://github.com/origamitower/metamagical#readme',
  'licence': 'MIT',
  'authors': ['Quildreen Motta <queen@robotlolita.me>'],
  'repository': 'git://github.com/origamitower/metamagical.git',
  'npmPackage': 'metamagical-interface',
  'copyright': '(c) 2016 Quildreen Motta',
  'maintainers': ['Quildreen Motta <queen@robotlolita.me> (http://robotlolita.me/)'],
  'complexity': 'O(number of enumberable properties)',
  'documentation': '\nReturns an array of property names in an object.'
});

function toEntries(object, properties) {
  return flatten(properties.map(function (name) {
    var p = descriptorOf(object, name);

    var result = [];

    if (p.get) {
      result.push({ name: name, value: p.get, kind: 'getter' });
    }
    if (p.set) {
      result.push({ name: name, value: p.set, kind: 'setter' });
    }
    if (p.value) {
      result.push({ name: name, value: p.value, kind: 'value' });
    }

    return result;
  }));
}

/*~
 * Returns an array of `key, descriptor` pairs for all own properties
 * in an object.
 * ---
 * complexity: O(number of own properties)
 */

__metamagical_withMeta(toEntries, {
  'name': 'toEntries',
  'source': 'function toEntries(object, properties) {\n  return flatten(properties.map(name => {\n    const p = descriptorOf(object, name);\n\n    let result = [];\n\n    if (p.get) {\n      result.push({ name, value: p.get, kind: \'getter\' });\n    }\n    if (p.set) {\n      result.push({ name, value: p.set, kind: \'setter\' });\n    }\n    if (p.value) {\n      result.push({ name, value: p.value, kind: \'value\' });\n    }\n\n    return result;\n  }));\n}',
  'signature': 'toEntries(object, properties)',
  'location': {
    'filename': 'packages/interface/src/index.js',
    'start': {
      'line': 145,
      'column': 0
    },
    'end': {
      'line': 163,
      'column': 1
    }
  },
  'module': 'metamagical-interface/src',
  'homepage': 'https://github.com/origamitower/metamagical#readme',
  'licence': 'MIT',
  'authors': ['Quildreen Motta <queen@robotlolita.me>'],
  'repository': 'git://github.com/origamitower/metamagical.git',
  'npmPackage': 'metamagical-interface',
  'copyright': '(c) 2016 Quildreen Motta',
  'maintainers': ['Quildreen Motta <queen@robotlolita.me> (http://robotlolita.me/)'],
  'complexity': 'O(properties.length)',
  'documentation': '\nConverts an array of property names into an array of Entry.'
});

function entriesOf(object) {
  return toEntries(object, propertiesOf(object));
}

/*~
 * Returns an array of `key, descriptor` pairs for all properties
 * in an object.
 * ---
 * complexity: O(number of properties)
 */

__metamagical_withMeta(entriesOf, {
  'name': 'entriesOf',
  'source': 'function entriesOf(object) {\n  return toEntries(object, propertiesOf(object));\n}',
  'signature': 'entriesOf(object)',
  'location': {
    'filename': 'packages/interface/src/index.js',
    'start': {
      'line': 171,
      'column': 0
    },
    'end': {
      'line': 173,
      'column': 1
    }
  },
  'module': 'metamagical-interface/src',
  'homepage': 'https://github.com/origamitower/metamagical#readme',
  'licence': 'MIT',
  'authors': ['Quildreen Motta <queen@robotlolita.me>'],
  'repository': 'git://github.com/origamitower/metamagical.git',
  'npmPackage': 'metamagical-interface',
  'copyright': '(c) 2016 Quildreen Motta',
  'maintainers': ['Quildreen Motta <queen@robotlolita.me> (http://robotlolita.me/)'],
  'complexity': 'O(number of own properties)',
  'documentation': '\nReturns an array of `key, descriptor` pairs for all own properties\nin an object.'
});

function allEntriesOf(object) {
  return toEntries(object, allPropertiesOf(object));
}

/*~
 * Compares two comparable objects.
 */

__metamagical_withMeta(allEntriesOf, {
  'name': 'allEntriesOf',
  'source': 'function allEntriesOf(object) {\n  return toEntries(object, allPropertiesOf(object));\n}',
  'signature': 'allEntriesOf(object)',
  'location': {
    'filename': 'packages/interface/src/index.js',
    'start': {
      'line': 181,
      'column': 0
    },
    'end': {
      'line': 183,
      'column': 1
    }
  },
  'module': 'metamagical-interface/src',
  'homepage': 'https://github.com/origamitower/metamagical#readme',
  'licence': 'MIT',
  'authors': ['Quildreen Motta <queen@robotlolita.me>'],
  'repository': 'git://github.com/origamitower/metamagical.git',
  'npmPackage': 'metamagical-interface',
  'copyright': '(c) 2016 Quildreen Motta',
  'maintainers': ['Quildreen Motta <queen@robotlolita.me> (http://robotlolita.me/)'],
  'complexity': 'O(number of properties)',
  'documentation': '\nReturns an array of `key, descriptor` pairs for all properties\nin an object.'
});

function compare(a, b) {
  return a < b ? -1 : a > b ? 1 : /* else */0;
}

/*~
 * Returns a list of categories for the given properties.
 */

__metamagical_withMeta(compare, {
  'name': 'compare',
  'source': 'function compare(a, b) {\n  return a < b      ?  -1\n  :      a > b      ?   1\n  :      /* else */     0;\n}',
  'signature': 'compare(a, b)',
  'location': {
    'filename': 'packages/interface/src/index.js',
    'start': {
      'line': 188,
      'column': 0
    },
    'end': {
      'line': 192,
      'column': 1
    }
  },
  'module': 'metamagical-interface/src',
  'homepage': 'https://github.com/origamitower/metamagical#readme',
  'licence': 'MIT',
  'authors': ['Quildreen Motta <queen@robotlolita.me>'],
  'repository': 'git://github.com/origamitower/metamagical.git',
  'npmPackage': 'metamagical-interface',
  'copyright': '(c) 2016 Quildreen Motta',
  'maintainers': ['Quildreen Motta <queen@robotlolita.me> (http://robotlolita.me/)'],
  'documentation': '\nCompares two comparable objects.\n '
});

function categoriseProperties(meta, entries) {
  var byName = function byName(a, b) {
    return compare(a.name, b.name);
  };
  var byCategory = function byCategory(a, b) {
    return compare(a.category, b.category);
  };

  var asCategoryObject = function asCategoryObject(_ref) {
    var _ref2 = _slicedToArray(_ref, 2);

    var category = _ref2[0];
    var members = _ref2[1];
    return { category: category, members: members };
  };

  var category = function category(_ref3) {
    var value = _ref3.value;
    return isObject(value) ? meta.for(value).get(meta.fields.category).getOrElse('(Uncategorised)') : /* else */'(Uncategorised)';
  };

  return groupBy(entries.sort(byName), category).map(asCategoryObject).sort(byCategory);
}

// --[ The Meta:Magical Interface ]------------------------------------

/*~
 * The Meta:Magical interface allows one to query meta-data associated
 * with a particular object, or attach new meta-data to any object
 * without modifying the object.
 *
 *
 * ## Why?
 *
 * Languages like Python, Ruby, Clojure, Smalltalk, and others support
 * interactively exploring their world of objects. For example, in
 * Python, one is able to look at the documentation of an object through
 * the `__doc__` property. In Smalltalk, the platform's browser tells
 * you what classes you have, which methods are available on them, their
 * source code, documentation, all in a searchable interactive
 * environment.
 *
 * JavaScript has a very limited support for this kind of reflective
 * capabilities. One may, for example, ask which properties an object
 * has, what's the name of a function, or its source, but there isn't
 * much beyond that which we could benefit from while exploring a
 * particular library in the REPL. There's nothing in JavaScript that
 * reifies a concept of documentation, making it accessible at runtime.
 *
 * In order to support a more exploration-driven interactive development
 * of applications, and even more accurate documentation in more static
 * forms (given that JavaScript is too dynamic to lend itself well to
 * static analysis documentation tools usually rely on), Meta:Magical
 * allows people to attach new, arbitrary meta-data to any object in the
 * system, and query that meta-data later.
 *
 * The Meta:Magical project is heavily influenced by work on Smalltalk
 * reflective environments, and Clojure's take on meta annotations for
 * runtime values, and this interface aims to be the basis of better
 * tooling for discoverable interactive environments and documentation
 * tools.
 *
 *
 * ## How Meta:Magical handles metadata?
 *
 * JavaScript has a prototype-based object-orientation model, which
 * basically means that each object defines its own layout (the methods,
 * properties, fields, etc. it has), rather than linking to a class that
 * defines such. Alongside the possibility of adding or modifying
 * properties in an object at any time, and the new `Symbol` feature,
 * this allows us to attach arbitrary meta-data to any object without
 * risking conflicts.
 *
 * There are two ways in which Meta:Magical supports attaching meta-data
 * to an object:
 *
 *   - By assigning an object to the global Meta:Magical symbol:
 *
 *         object[Symbol.for('@@meta:magical')] = { ... };
 *
 *   - By using the Interface's `.set()` method, which assigns meta-data
 *     to an object using an internal `WeakMap` to avoid problems
 *     modifying non-owned objects, specially those that have been
 *     frozen::
 *
 *         const frozen = Object.freeze({});
 *         Interface.for(frozen).set('name', 'frozen');
 *
 * Meta-data associated with an object through the `WeakMap` has
 * precedence over meta-data attached directly on the object, as a
 * property. This allows people to refine existing meta-data and provide
 * new ones for objects from the outside.
 *
 *
 * ## Querying meta-data
 *
 * The Meta:Magical interface is an object that wraps another object,
 * and lets you reflect over meta-properties associated with that
 * object, by both querying or updating them.
 *
 * The `object` method defines which object this interface is looking
 * at. By default, the interface starts looking at itself, but it can be
 * refined to look at another object, which can be done by inheriting
 * from it explicitly or just using the `.for()` method::
 *
 *     Interface.getByName('name');
 *     // ==> 'Interface'
 *
 *     const getInterface = Interface.for(Interface.getByName);
 *     getInterface.getByName('name');
 *     // ==> 'getByName'
 *
 *     const myInterface = getInterface.for(Interface);
 *     myInterface.getByName('name');
 *     // ==> 'Interface'
 *
 * At any point you can use the `object` method to retrieve the
 * object the interface is looking at:
 *
 *     Interface.object
 *     // ==> Interface
 *
 *
 * ### Containership and Inheritance
 *
 * Objects form hierarchies of data, but given a JavaScript object
 * one is only able to ask which objects are under that, it's not
 * possible to query which objects contains a particular value.
 * This makes interactive exploration in a REPL harder, because
 * we can't figure out the context of a particular value (where
 * does this belong to?).
 *
 * To solve this, Meta:Magical introduces a special piece of metadata,
 * `belongsTo`, which lazily provides the missing link::
 *
 *     const root = {
 *       child: { }
 *     };
 *     root.child[Symbol.for('@@meta:magical')] = {
 *       belongsTo() { return root },
 *       name: 'child'
 *     };
 *
 * This allows one to retrieve which object canonically holds the
 * definition of a particular value. So, if one has a function like
 * `get`, they can retrieve the broader context in which this function
 * lives::
 *
 *     const getMeta = Interface.forObject(Interface.get);
 *     getMeta.getByName('belongsTo').getOrElse(null)();
 *     // ==> Interface
 *
 * Internally, Meta:Magical uses this information to propagate some
 * metadata from the broader context (parent object) to the current
 * context. Things such as `licence`, `repository`, `copyright`, and
 * others allow this kind of inheritance::
 *
 *     root[Symbol.for('@@meta:magical')] = {
 *       licence: 'CC0'
 *     };
 *
 *     Interface.for(root.child).getInherited('licence').getOrElse(null);
 *     // ==> 'CCO'
 *
 *
 * ### Propagation
 *
 * Another aspect that's important when you have a hierarchy of objects
 * is that objects are made out of several smaller pieces. And these
 * pieces impact the metadata about the top objects. For example, if
 * a module contains a single experimental function, then it might make
 * sense to mark the module as experimental.
 *
 * Meta:Magical supports this through the concept of propagation. Given
 * a root object, and a metadata field, one may retrieve all of the
 * values for that field in all objects contained in it. The interface
 * handles all of the recursion and cycles for you::
 *
 *     const root = {
 *       childA: {
 *         childB: { }
 *       }
 *     };
 *     root.childA[Symbol.for('@@meta:magical')] = {
 *       stability: 'experimental'
 *     };
 *     root.childB[Symbol.for('@@meta:magical')] = {
 *       stability: 'stable'
 *     };
 *
 *     Interface.for(root).getPropagatedMeta('stability');
 *     // ==> ['experimental', 'stable']
 *
 *
 * ### Simplifying querying with fields
 *
 * Because different pieces of metadata have different behaviours
 * with inheritance and propagation, and because propagated metadata
 * needs to be merged for it to make sense (an array of stability
 * indexes is often meaningless, for example), Meta:Magical has a
 * concept of fields.
 *
 * `Field`s are an object that describe how a particular metadata
 * is handled, providing a name, inheritance and propagation
 * behaviours, and a way to merge metadata. All of this is used
 * by the `.get()` method to provide a value for the metadata.
 *
 * Taking the example in the previous section, a field could
 * provide an overall stability for the whole module::
 *
 *     const root = {
 *       childA: {
 *         childB: { }
 *       }
 *     };
 *     root.childA[Symbol.for('@@meta:magical')] = {
 *       stability: 'experimental'
 *     };
 *     root.childB[Symbol.for('@@meta:magical')] = {
 *       stability: 'stable'
 *     };
 *
 *     const stability = Interface.fields.stability;
 *     Interface.for(root).get(stability).getOrElse(null);
 *     // ==> 'experimental'
 *
 *     Interface.for(root.childA.childB).get(stability).getOrElse(null);
 *     // ==> 'stable'
 *
 * For more information on fields, see the `.fields` property
 * exposed by the interface.
 *
 *
 * ## Updating meta-data
 *
 * The interface object also handles updating meta-data. The newly
 * associated meta-data is stored in a `WeakMap`, rather than on the
 * object itself, to avoid problems with modifying unowned, and frozen
 * objects.
 *
 * In order to associate new metadata one needs to construct an
 * `Interface` pointing to the object one wants to associate metadata
 * with, and then use the `.set(name, value)` to update the metadata::
 *
 *     const x = {};
 *     const xMeta = Interface.for(x);
 *     xMeta.set('name', 'x');
 *     xMeta.getByName('name'); // ==> 'x'
 *
 * Multiple metadata may be provided as an object through the
 * `.update(meta)` method. All own enumerable key/value pairs provided
 * will replace the existing metadata on the object::
 *
 *     xMeta.update({ name: 'X' });
 *     xMeta.getByName('name'); // ==> 'X'
 *
 *
 * ## Known issues with Meta:Magical
 *
 * Meta:Magical's use of global symbols for associating meta-data with
 * the objects doesn't have any issues, although in the unlikely event
 * that someone uses a global symbol with the `"@@meta:magical"` key
 * that would conflict with this library's use of the symbol. As long as
 * you only use the Symbol approach, there are no problems to worry
 * about.
 *
 * The use of a `WeakMap` to keep track of additional metadata for
 * unowned objects, on the other hand, is somewhat of a problem due to
 * JavaScript's semantics:
 *
 *   - The `metamagical-interface` library should be loaded only once.
 *     Because the library relies on a single `WeakMap` to keep track
 *     of additional metadata, having different libraries (and
 *     consequently different state) would lead to inconsistencies and
 *     unpredictable behaviour.
 *
 *   - All code realms should share the same instance of the
 *     `metamagical-interface`. Because a JavaScript VM may have
 *     different Code Realms (essentially, global execution contexts),
 *     it's important that all of them share the same Interface
 *     instance, otherwise metadata attached in one realm would not be
 *     visible in another.
 *
 *   - The `metamagical-interface` module uses reference equality, so it
 *     will treat objects from different realms as different objects, as
 *     it will treat duplicated isntances of a particular module (as
 *     could happen in npm) as different objects. There is no way of
 *     avoiding this problem.
 *
 * To ensure that one only has a single instance of the
 * `metamagical-interface` module in their application, all modules that
 * depend on this interface should be parameterised and expect an
 * outsider to provide the proper object, rather than require it
 * directly. In essence, modules that depend on the
 * `metamagical-interface` should be written as:
 *
 *     module.exports = function(metamagical) {
 *       return {
 *         foo() { return metamagical.get('name') }
 *       };
 *     }
 *
 * Rather than:
 *
 *     const metamagical = require('metamagical-interface');
 *     module.exports = {
 *       foo() { return metamagical.get('name') }
 *     }
 *
 * ---
 * stability : experimental
 * module    : metamagical-interface
 * category  : Metadata
 * isModule  : true
 * platforms:
 *   - ECMAScript 2015
 */

__metamagical_withMeta(categoriseProperties, {
  'name': 'categoriseProperties',
  'source': 'function categoriseProperties(meta, entries) {\n  const byName     = (a, b) => compare(a.name, b.name);\n  const byCategory = (a, b) => compare(a.category, b.category);\n\n  const asCategoryObject = ([category, members]) => ({ category, members });\n\n  const category = ({ value }) =>\n    isObject(value) ?  meta.for(value)\n                           .get(meta.fields.category)\n                           .getOrElse(\'(Uncategorised)\')\n    : /* else */       \'(Uncategorised)\';\n\n  return groupBy(entries.sort(byName), category)\n           .map(asCategoryObject)\n           .sort(byCategory);\n}',
  'signature': 'categoriseProperties(meta, entries)',
  'location': {
    'filename': 'packages/interface/src/index.js',
    'start': {
      'line': 197,
      'column': 0
    },
    'end': {
      'line': 212,
      'column': 1
    }
  },
  'module': 'metamagical-interface/src',
  'homepage': 'https://github.com/origamitower/metamagical#readme',
  'licence': 'MIT',
  'authors': ['Quildreen Motta <queen@robotlolita.me>'],
  'repository': 'git://github.com/origamitower/metamagical.git',
  'npmPackage': 'metamagical-interface',
  'copyright': '(c) 2016 Quildreen Motta',
  'maintainers': ['Quildreen Motta <queen@robotlolita.me> (http://robotlolita.me/)'],
  'documentation': '\nReturns a list of categories for the given properties.\n '
});

var Interface = __metamagical_withMeta(Refinable.refine((_Refinable$refine = {
  fields: fields,
  Stability: Stability,

  get object() {
    return this;
  },

  for: function _for(value) {
    assertObject(value);

    return this.refine({
      object: value
    });
  },
  getOwnMeta: function getOwnMeta(name) {
    var meta = getMeta(this.object);

    return name in meta ? Maybe.Just(meta[name]) : /* otherwise */Maybe.Nothing();
  },
  getInheritedMeta: function getInheritedMeta(name) {
    var _this = this;

    return this.getOwnMeta('belongsTo').chain(function (parentFn) {
      var parent = parentFn();
      return _this.for(parent).getOwnMeta(name).orElse(function (_) {
        return _this.for(parent).getInheritedMeta(name);
      });
    });
  },
  getPropagatedMeta: function getPropagatedMeta(name) {
    var _this2 = this;

    var visited = new Set();

    var collectFrom = function collectFrom(meta) {
      var object = meta.object;

      if (visited.has(object)) {
        return [];
      }

      visited.add(object);

      return flatten(entriesOf(object).map(function (child) {
        if (!isObject(child.value) || visited.has(child.value)) {
          return [];
        } else {
          var childMeta = _this2.for(child.value);
          return childMeta.getOwnMeta(name).map(function (x) {
            return [x];
          }).getOrElse([]).concat(collectFrom(childMeta));
        }
      }));
    };

    return collectFrom(this);
  },
  get: function get(field) {
    var _this3 = this;

    return this.getOwnMeta(field.name).orElse(function (_) {
      return field.allowInheritance ? _this3.getInheritedMeta(field.name) : /* otherwise */Maybe.Nothing();
    }).orElse(function (_) {
      return field.allowPropagation ? field.merge(_this3.getPropagatedMeta(field.name)) : /* otherwise */Maybe.Nothing();
    });
  },
  getByName: function getByName(name) {
    return this.get(this.fields.Field.refine({ name: name }));
  },
  set: function set(field, value) {
    var object = this.object;
    var meta = metadata.get(object) || {};

    meta[field] = value;
    metadata.set(object, meta);

    return this;
  },
  update: function update(meta) {
    var _this4 = this;

    keys(meta).forEach(function (key) {
      return _this4.set(key, meta[key]);
    });
  },
  property: function property(name) {
    return name in this.object ? Maybe.Just(this.for(this.object[name])) : /* otherwise */Maybe.Nothing();
  },
  getter: function getter(name) {
    var _this5 = this;

    return getGetterSetter(this.object, name, 'get').map(function (x) {
      return _this5.for(x);
    });
  },
  setter: function setter(name) {
    var _this6 = this;

    return getGetterSetter(this.object, name, 'set').map(function (x) {
      return _this6.for(x);
    });
  },
  prototype: function prototype() {
    var parent = prototypeOf(this.object);
    return parent != null ? Maybe.Just(this.for(parent)) : /* otherwise */Maybe.Nothing();
  },
  properties: function properties() {
    return categoriseProperties(this, entriesOf(this.object));
  },
  allProperties: function allProperties() {
    return categoriseProperties(this, allEntriesOf(this.object));
  }
}, __metamagical_withMeta(Object.getOwnPropertyDescriptor(_Refinable$refine, 'object').get, {
  'name': 'object',
  'source': 'get object() {\n    return this;\n  }',
  'signature': 'get object()',
  'belongsTo': function belongsTo() {
    return Interface;
  },
  'category': 'State and configuration',
  'seeAlso': [{
    'type': 'entity',
    'path': '.for',
    'reason': 'A convenience method for changing the context.'
  }],
  'type': 'Interface. => Object \'a\n \n',
  'documentation': '\nThe current context of the Meta:Magical interface.\n\nA Meta:Magical interface has a current context, that is the\nobject to retrieve metadata from, or associate new metadata\nwith. This method provides such context.\n\nBy default the interface starts looking at itself. But this\ncan be changed by inheriting from the interface:\n\n    const x = {\n      [Symbol.for(\'@@meta:magical\')]: {\n        name: \'x\'\n      }\n    };\n    const meta = Interface.refine({\n      object: x\n    });\n\n    meta.get(\'name\'); // ==> \'x\'\n\nA much more convenient way of changing the context is by using\nthe `.for(object)` method, however:\n\n    Interface.for(x).get(\'name\'); // ==> \'x\'\n',
  'examples': [{
    'name': '',
    'call': __metamagical_withMeta(function () {
      var x = _defineProperty({}, Symbol.for('@@meta:magical'), { name: 'x' });var meta = Interface.refine({ object: x });meta.get('name'); // ==> 'x'
    }, {
      'source': 'const x = {\n  [Symbol.for(\'@@meta:magical\')]: {\n    name: \'x\'\n  }\n};\nconst meta = Interface.refine({\n  object: x\n});\n\nmeta.get(\'name\'); // ==> \'x\''
    }),
    'inferred': true
  }, {
    'name': '',
    'call': __metamagical_withMeta(function () {
      Interface.for(x).get('name'); // ==> 'x'
    }, {
      'source': 'Interface.for(x).get(\'name\'); // ==> \'x\''
    }),
    'inferred': true
  }]
}), __metamagical_withMeta(_Refinable$refine['for'], {
  'name': 'for',
  'source': 'for(value) {\n    assertObject(value);\n\n    return this.refine({\n      object: value\n    });\n  }',
  'signature': 'for(value)',
  'belongsTo': function belongsTo() {
    return Interface;
  },
  'category': 'State and configuration',
  'seeAlso': [{
    'type': 'entity',
    'path': '.object',
    'reason': 'Retrieving the current context of the interface.'
  }],
  'type': '(proto is Interface).(Object \'a) => Interface <: proto\n \n',
  'documentation': '\nChanges the current context of the Meta:Magical object.\n\nThis method allows changing the current context of the object\nin a more convenient way than explicitly inheriting from the\nobject:\n\n    const x = {\n      [Symbol.for(\'@@meta:magical\')]: {\n        name: \'x\'\n      }\n    };\n    const xMeta = Interface.for(x);\n    xMeta.get(\'name\'); // ==> \'x\'\n',
  'examples': [{
    'name': '',
    'call': __metamagical_withMeta(function () {
      var x = _defineProperty({}, Symbol.for('@@meta:magical'), { name: 'x' });var xMeta = Interface.for(x);xMeta.get('name'); // ==> 'x'
    }, {
      'source': 'const x = {\n  [Symbol.for(\'@@meta:magical\')]: {\n    name: \'x\'\n  }\n};\nconst xMeta = Interface.for(x);\nxMeta.get(\'name\'); // ==> \'x\''
    }),
    'inferred': true
  }]
}), __metamagical_withMeta(_Refinable$refine['getOwnMeta'], {
  'name': 'getOwnMeta',
  'source': 'getOwnMeta(name) {\n    const meta = getMeta(this.object);\n\n    return name in meta ?   Maybe.Just(meta[name])\n    :      /* otherwise */  Maybe.Nothing();\n  }',
  'signature': 'getOwnMeta(name)',
  'belongsTo': function belongsTo() {
    return Interface;
  },
  'category': 'Auxiliary methods for querying metadata',
  'type': 'Interface.(String) => Maybe Any\n \n',
  'documentation': '\nRetrieves metadata defined directly on the current interface\'s context.\n\n\n    const x = {[Symbol.for(\'@@meta:magical\')]: {\n      name: \'x\'\n    }};\n\n    Interface.for(x).getOwnMeta(\'name\').getOrElse(\'Anonymous\');\n    // ==> \'x\'\n    Interface.for({}).getOwnMeta(\'name\').getOrElse(\'Anonymous\');\n    // ==> \'Anonymous\'\n'
}), __metamagical_withMeta(_Refinable$refine['getInheritedMeta'], {
  'name': 'getInheritedMeta',
  'source': 'getInheritedMeta(name) {\n    return this.getOwnMeta(\'belongsTo\').chain(parentFn => {\n      const parent = parentFn();\n      return this.for(parent).getOwnMeta(name).orElse(_ =>\n        this.for(parent).getInheritedMeta(name)\n      );\n    });\n  }',
  'signature': 'getInheritedMeta(name)',
  'belongsTo': function belongsTo() {
    return Interface;
  },
  'category': 'Auxiliary methods for querying metadata',
  'type': 'Interface.(String) => Maybe Any\n \n',
  'documentation': '\nRetrieves metadata defined in the closest parent for the interface\'s\ncontext.\n\nIn JavaScript objects may contain other objects, but we can\'t know\nwhat object contains another object (given that many objects might).\nIn order to support inherited meta-data for classes and objects,\nMeta:Magical allows one to annotate this missing link with the\n`belongsTo` field:\n\n    const root = {\n      child: { }\n    };\n    root[Symbol.for(\'@@meta:magical\')] = {\n      category: \'Objects\'\n    };\n    root.child[Symbol.for(\'@@meta:magical\')] = {\n      belongsTo() { return root; }\n    };\n\nOne may then ask for the meta-data in this containership-chain:\n\n    Interface.for(root.child)\n             .getInheritedMeta(\'category\')\n             .getOrElse(\'Uncategorised\');\n    // ==> \'Objects\'\n\n    Interface.for(root)\n             .getInheritedMeta(\'category\')\n             .getOrElse(\'Uncategorised\');\n    // ==> \'Uncategorised\'\n',
  'examples': [{
    'name': '',
    'call': __metamagical_withMeta(function () {
      var root = { child: {} };root[Symbol.for('@@meta:magical')] = { category: 'Objects' };root.child[Symbol.for('@@meta:magical')] = {
        belongsTo: function belongsTo() {
          return root;
        }
      };
    }, {
      'source': 'const root = {\n  child: { }\n};\nroot[Symbol.for(\'@@meta:magical\')] = {\n  category: \'Objects\'\n};\nroot.child[Symbol.for(\'@@meta:magical\')] = {\n  belongsTo() { return root; }\n};'
    }),
    'inferred': true
  }, {
    'name': '',
    'call': __metamagical_withMeta(function () {
      Interface.for(root.child).getInheritedMeta('category').getOrElse('Uncategorised'); // ==> 'Objects'
      Interface.for(root).getInheritedMeta('category').getOrElse('Uncategorised'); // ==> 'Uncategorised'
    }, {
      'source': 'Interface.for(root.child)\n         .getInheritedMeta(\'category\')\n         .getOrElse(\'Uncategorised\');\n// ==> \'Objects\'\n\nInterface.for(root)\n         .getInheritedMeta(\'category\')\n         .getOrElse(\'Uncategorised\');\n// ==> \'Uncategorised\''
    }),
    'inferred': true
  }]
}), __metamagical_withMeta(_Refinable$refine['getPropagatedMeta'], {
  'name': 'getPropagatedMeta',
  'source': 'getPropagatedMeta(name) {\n    let visited = new Set();\n\n    const collectFrom = (meta) => {\n      const object = meta.object;\n\n      if (visited.has(object)) {\n        return [];\n      }\n\n      visited.add(object);\n\n      return flatten(entriesOf(object).map(child => {\n        if (!isObject(child.value) || visited.has(child.value)) {\n          return [];\n        } else {\n          const childMeta = this.for(child.value);\n          return childMeta.getOwnMeta(name)\n                          .map(x => [x])\n                          .getOrElse([])\n                          .concat(collectFrom(childMeta));\n        }\n      }));\n    };\n\n    return collectFrom(this);\n  }',
  'signature': 'getPropagatedMeta(name)',
  'belongsTo': function belongsTo() {
    return Interface;
  },
  'category': 'Auxiliary methods for querying metadata',
  'complexity': 'O(n), `n` is the number of obects inside the current context',
  'type': 'Interface.(String) => Array Any\n \n',
  'documentation': '\nRetrieves metadata defined in the children of the interface\'s context.\n\nThis gives you an array of the values for the given metadata field defined\nin the children (direct or indirect) of the current interface\'s context:\n\n    const root = {\n      childA: { },\n      childB: { }\n    };\n    childA[Symbol.for(\'@@meta:magical\')] = {\n      stability: \'experimental\'\n    };\n    childA[Symbol.for(\'@@meta:magical\')] = {\n      stability: \'stable\'\n    };\n\n    Interface.for(root).getPropagatedMeta(\'stability\');\n    // ==> [\'experimental\', \'stable\']\n',
  'examples': [{
    'name': '',
    'call': __metamagical_withMeta(function () {
      var root = { childA: {}, childB: {} };childA[Symbol.for('@@meta:magical')] = { stability: 'experimental' };childA[Symbol.for('@@meta:magical')] = { stability: 'stable' };Interface.for(root).getPropagatedMeta('stability'); // ==> ['experimental', 'stable']
    }, {
      'source': 'const root = {\n  childA: { },\n  childB: { }\n};\nchildA[Symbol.for(\'@@meta:magical\')] = {\n  stability: \'experimental\'\n};\nchildA[Symbol.for(\'@@meta:magical\')] = {\n  stability: \'stable\'\n};\n\nInterface.for(root).getPropagatedMeta(\'stability\');\n// ==> [\'experimental\', \'stable\']'
    }),
    'inferred': true
  }]
}), __metamagical_withMeta(_Refinable$refine['get'], {
  'name': 'get',
  'source': 'get(field) {\n    return this.getOwnMeta(field.name)\n               .orElse(_ =>\n                 field.allowInheritance ?  this.getInheritedMeta(field.name)\n                 : /* otherwise */         Maybe.Nothing()\n               ).orElse(_ =>\n                 field.allowPropagation ?  field.merge(this.getPropagatedMeta(field.name))\n                 : /* otherwise */         Maybe.Nothing()\n               );\n  }',
  'signature': 'get(field)',
  'belongsTo': function belongsTo() {
    return Interface;
  },
  'category': 'Querying metadata',
  'complexity': 'O(n), `n` is the number of objects inside the current context',
  'type': 'Interface.(Field) => Maybe Any\n \n',
  'documentation': '\nRetrieves metadata for the given field from the interface\'s current\ncontext.\n\nThis will try retrieving metadata stored directly in the current context,\nand fallback to metadata inherited from a parent object (through the\n`belongsTo` metadata), or metadata propagated from the values of the\nproperties in the object, if the provided field allows either.\n'
}), __metamagical_withMeta(_Refinable$refine['getByName'], {
  'name': 'getByName',
  'source': 'getByName(name) {\n    return this.get(this.fields.Field.refine({ name }));\n  }',
  'signature': 'getByName(name)',
  'belongsTo': function belongsTo() {
    return Interface;
  },
  'category': 'Querying metadata',
  'complexity': 'O(n), `n` is the number of objects inside the current context',
  'type': 'Interface.(String) => Maybe Any\n \n',
  'documentation': '\nRetrieves metadata with the given name from the interface\'s current context.\n'
}), __metamagical_withMeta(_Refinable$refine['set'], {
  'name': 'set',
  'source': 'set(field, value) {\n    const object = this.object;\n    let meta     = metadata.get(object) || {};\n\n    meta[field] = value;\n    metadata.set(object, meta);\n\n    return this;\n  }',
  'signature': 'set(field, value)',
  'belongsTo': function belongsTo() {
    return Interface;
  },
  'category': 'Querying and updating metadata',
  'seeAlso': [{
    'type': 'entity',
    'path': '.update',
    'reason': 'Convenience for updating multiple metadata fields'
  }],
  'type': '(a is Interface).(String, Any) => Interface :: mutates a\n \n',
  'documentation': '\nUpdates a single metadata field associated with the current interface\'s\ncontext.\n\n\n    const a     = Object.freeze({});\n    const aMeta = Interface.for(a);\n\n    aMeta.get(\'name\').getOrElse(\'Anonymous\');  // ==> \'Anonymous\'\n\n    aMeta.set(\'name\', \'a\');   // ==> aMeta\n    aMeta.get(\'name\').get();  // ==> \'a\'\n\nThis operation associates new metadata with the current interface\'s context.\nMetadata is attached by using the internal `WeakMap`, and as such can be\nused for frozen objects as well.\n\n> | **NOTE**\n> | Since this relies on a global `WeakMap`, it\'s subject to the\n> | limitations described in the `Interface`.\n'
}), __metamagical_withMeta(_Refinable$refine['update'], {
  'name': 'update',
  'source': 'update(meta) {\n    keys(meta).forEach(key => this.set(key, meta[key]));\n  }',
  'signature': 'update(meta)',
  'belongsTo': function belongsTo() {
    return Interface;
  },
  'category': 'Querying and updating metadata',
  'type': '(a is Interface).(String, Object Any) => Interface :: mutates a\n \n',
  'documentation': '\nUpdates many metadata fields associated with the current interface\'s\ncontext.\n\n\n    const a     = Object.freeze({});\n    const aMeta = Interface.for(a);\n\n    aMeta.get(\'type\').getOrElse(\'Unknown\'); // ==> \'Unknown\'\n\n    aMeta.update({ name: \'a\', type: \'Object\' }); // ==> aMeta\n    aMeta.get(\'name\').get();  // ==> \'a\'\n    aMeta.get(\'type\').get();  // ==> \'Object\'\n\nThis operation associates new metadata with the current interface\'s context.\nMetadata is attached by using the internal `WeakMap`, and as such can be\nused for frozen objects as well.\n\n> | **NOTE**\n> | Since this relies on a global `WeakMap`, it\'s subject to the\n> | limitations described in the `Interface`.\n'
}), __metamagical_withMeta(_Refinable$refine['property'], {
  'name': 'property',
  'source': 'property(name) {\n    return name in this.object ?  Maybe.Just(this.for(this.object[name]))\n    :      /* otherwise */        Maybe.Nothing();\n  }',
  'signature': 'property(name)',
  'belongsTo': function belongsTo() {
    return Interface;
  },
  'category': 'Navigating the context',
  'type': 'Interface.(String) => Maybe Interface\n \n',
  'documentation': '\nReturns an interface pointing to the given property of the current\ncontext.\n\n\n     Interface.property(\'get\').get().object;\n     // ==> Interface.get\n'
}), __metamagical_withMeta(_Refinable$refine['getter'], {
  'name': 'getter',
  'source': 'getter(name) {\n    return getGetterSetter(this.object, name, \'get\').map(x => this.for(x));\n  }',
  'signature': 'getter(name)',
  'belongsTo': function belongsTo() {
    return Interface;
  },
  'category': 'Navigating the context',
  'type': 'Interface.(String) => Maybe Interface\n \n',
  'documentation': '\nReturns an interface pointing to a getter with the given name in the\ncurrent context.\n\n\n    const x = { get value() { } };\n    const valueGetter = Object.getOwnPropertyDescriptor(x, \'value\').get;\n    Interface.for(x).getter(\'value\').get().object;\n    // ==> valueGetter\n'
}), __metamagical_withMeta(_Refinable$refine['setter'], {
  'name': 'setter',
  'source': 'setter(name) {\n    return getGetterSetter(this.object, name, \'set\').map(x => this.for(x));\n  }',
  'signature': 'setter(name)',
  'belongsTo': function belongsTo() {
    return Interface;
  },
  'category': 'Navigating the context',
  'type': 'Interface.(String) => Maybe Interface\n \n',
  'documentation': '\nReturns an interface pointing to a setter with the given name in the\ncurrent context.\n\n\n    const x = { set value(arg){ } };\n    const valueSetter = Object.getOwnPropertyDescriptor(x, \'value\').set;\n    Interface.for(x).setter(\'value\').get().object;\n    // ==> valueSetter\n'
}), __metamagical_withMeta(_Refinable$refine['prototype'], {
  'name': 'prototype',
  'source': 'prototype() {\n    const parent = prototypeOf(this.object);\n    return parent != null ?  Maybe.Just(this.for(parent))\n    :      /* otherwise */   Maybe.Nothing();\n  }',
  'signature': 'prototype()',
  'belongsTo': function belongsTo() {
    return Interface;
  },
  'category': 'Navigating the context',
  'type': 'Interface.() => Maybe Interface\n \n',
  'documentation': '\nReturns an interface pointing to the prototype of the current context\'s\n`[[Prototype]]`.\n\n\n    const x = {};\n    const y = Object.create(x);\n    Interface.for(y).prototype().get().object;\n    // ==> x\n'
}), __metamagical_withMeta(_Refinable$refine['properties'], {
  'name': 'properties',
  'source': 'properties() {\n    return categoriseProperties(this, entriesOf(this.object));\n  }',
  'signature': 'properties()',
  'belongsTo': function belongsTo() {
    return Interface;
  },
  'category': 'Additional reflective methods',
  'type': 'type PropertyKind is \'value\' or \'getter\' or \'setter\'\ntype Property     is { name: String, value: Any, kind: PropertyKind }\n\nInterface.() => Array { category: String, members: Array Property }\n \n',
  'documentation': '\nRetrieves a categorised list of properties owned by the current\ncontext.\n'
}), __metamagical_withMeta(_Refinable$refine['allProperties'], {
  'name': 'allProperties',
  'source': 'allProperties() {\n    return categoriseProperties(this, allEntriesOf(this.object));\n  }',
  'signature': 'allProperties()',
  'belongsTo': function belongsTo() {
    return Interface;
  },
  'category': 'Additional reflective methods',
  'type': 'type PropertyKind is \'value\' or \'getter\' or \'setter\'\ntype Property     is { name: String, value: Any, kind: PropertyKind }\n\nInterface.() => Array { category: String, members: Array Property }\n \n',
  'documentation': '\nRetrieves a categorised list of properties in the current\ncontext.\n'
}), _Refinable$refine)), {
  'name': 'Interface',
  'source': 'Refinable.refine({\n  // ---[ Related objects ]--------------------------------------------\n  fields: fields,\n  Stability: Stability,\n\n  // ---[ State & Configuration ]--------------------------------------\n\n  /*~\n   * The current context of the Meta:Magical interface.\n   *\n   * A Meta:Magical interface has a current context, that is the\n   * object to retrieve metadata from, or associate new metadata\n   * with. This method provides such context.\n   *\n   * By default the interface starts looking at itself. But this\n   * can be changed by inheriting from the interface::\n   *\n   *     const x = {\n   *       [Symbol.for(\'@@meta:magical\')]: {\n   *         name: \'x\'\n   *       }\n   *     };\n   *     const meta = Interface.refine({\n   *       object: x\n   *     });\n   *\n   *     meta.get(\'name\'); // ==> \'x\'\n   *\n   * A much more convenient way of changing the context is by using\n   * the `.for(object)` method, however::\n   *\n   *     Interface.for(x).get(\'name\'); // ==> \'x\'\n   *\n   * ---\n   * category: State and configuration\n   *\n   * seeAlso:\n   *   - type: entity\n   *     path: .for\n   *     reason: A convenience method for changing the context.\n   *\n   * type: |\n   *   Interface. => Object \'a\n   */\n  get object() {\n    return this;\n  },\n\n\n  /*~\n   * Changes the current context of the Meta:Magical object.\n   *\n   * This method allows changing the current context of the object\n   * in a more convenient way than explicitly inheriting from the\n   * object::\n   *\n   *     const x = {\n   *       [Symbol.for(\'@@meta:magical\')]: {\n   *         name: \'x\'\n   *       }\n   *     };\n   *     const xMeta = Interface.for(x);\n   *     xMeta.get(\'name\'); // ==> \'x\'\n   *\n   * ---\n   * category: State and configuration\n   *\n   * seeAlso:\n   *   - type: entity\n   *     path: .object\n   *     reason: Retrieving the current context of the interface.\n   *\n   * type: |\n   *   (proto is Interface).(Object \'a) => Interface <: proto\n   */\n  for(value) {\n    assertObject(value);\n\n    return this.refine({\n      object: value\n    });\n  },\n\n\n  // ---[ Auxiliary Methods for Querying Metadata ]--------------------\n\n  /*~\n   * Retrieves metadata defined directly on the current interface\'s context.\n   *\n   * ::\n   *     const x = {[Symbol.for(\'@@meta:magical\')]: {\n   *       name: \'x\'\n   *     }};\n   *\n   *     Interface.for(x).getOwnMeta(\'name\').getOrElse(\'Anonymous\');\n   *     // ==> \'x\'\n   *     Interface.for({}).getOwnMeta(\'name\').getOrElse(\'Anonymous\');\n   *     // ==> \'Anonymous\'\n   *\n   * ---\n   * category: Auxiliary methods for querying metadata\n   * type: |\n   *   Interface.(String) => Maybe Any\n   */\n  getOwnMeta(name) {\n    const meta = getMeta(this.object);\n\n    return name in meta ?   Maybe.Just(meta[name])\n    :      /* otherwise */  Maybe.Nothing();\n  },\n\n\n  /*~\n   * Retrieves metadata defined in the closest parent for the interface\'s\n   * context.\n   *\n   * In JavaScript objects may contain other objects, but we can\'t know\n   * what object contains another object (given that many objects might).\n   * In order to support inherited meta-data for classes and objects,\n   * Meta:Magical allows one to annotate this missing link with the\n   * `belongsTo` field::\n   *\n   *     const root = {\n   *       child: { }\n   *     };\n   *     root[Symbol.for(\'@@meta:magical\')] = {\n   *       category: \'Objects\'\n   *     };\n   *     root.child[Symbol.for(\'@@meta:magical\')] = {\n   *       belongsTo() { return root; }\n   *     };\n   *\n   * One may then ask for the meta-data in this containership-chain::\n   *\n   *     Interface.for(root.child)\n   *              .getInheritedMeta(\'category\')\n   *              .getOrElse(\'Uncategorised\');\n   *     // ==> \'Objects\'\n   *\n   *     Interface.for(root)\n   *              .getInheritedMeta(\'category\')\n   *              .getOrElse(\'Uncategorised\');\n   *     // ==> \'Uncategorised\'\n   *\n   * ---\n   * category: Auxiliary methods for querying metadata\n   * type: |\n   *   Interface.(String) => Maybe Any\n   */\n  getInheritedMeta(name) {\n    return this.getOwnMeta(\'belongsTo\').chain(parentFn => {\n      const parent = parentFn();\n      return this.for(parent).getOwnMeta(name).orElse(_ =>\n        this.for(parent).getInheritedMeta(name)\n      );\n    });\n  },\n\n\n  /*~\n   * Retrieves metadata defined in the children of the interface\'s context.\n   *\n   * This gives you an array of the values for the given metadata field defined\n   * in the children (direct or indirect) of the current interface\'s context::\n   *\n   *     const root = {\n   *       childA: { },\n   *       childB: { }\n   *     };\n   *     childA[Symbol.for(\'@@meta:magical\')] = {\n   *       stability: \'experimental\'\n   *     };\n   *     childA[Symbol.for(\'@@meta:magical\')] = {\n   *       stability: \'stable\'\n   *     };\n   *\n   *     Interface.for(root).getPropagatedMeta(\'stability\');\n   *     // ==> [\'experimental\', \'stable\']\n   *\n   * ---\n   * category   : Auxiliary methods for querying metadata\n   * complexity : O(n), `n` is the number of obects inside the current context\n   *\n   * type: |\n   *   Interface.(String) => Array Any\n   */\n  getPropagatedMeta(name) {\n    let visited = new Set();\n\n    const collectFrom = (meta) => {\n      const object = meta.object;\n\n      if (visited.has(object)) {\n        return [];\n      }\n\n      visited.add(object);\n\n      return flatten(entriesOf(object).map(child => {\n        if (!isObject(child.value) || visited.has(child.value)) {\n          return [];\n        } else {\n          const childMeta = this.for(child.value);\n          return childMeta.getOwnMeta(name)\n                          .map(x => [x])\n                          .getOrElse([])\n                          .concat(collectFrom(childMeta));\n        }\n      }));\n    };\n\n    return collectFrom(this);\n  },\n\n\n  // ---[ Querying Metadata ]------------------------------------------\n\n  /*~\n   * Retrieves metadata for the given field from the interface\'s current\n   * context.\n   *\n   * This will try retrieving metadata stored directly in the current context,\n   * and fallback to metadata inherited from a parent object (through the\n   * `belongsTo` metadata), or metadata propagated from the values of the\n   * properties in the object, if the provided field allows either.\n   *\n   * ---\n   * category   : Querying metadata\n   * complexity : O(n), `n` is the number of objects inside the current context\n   *\n   * type: |\n   *   Interface.(Field) => Maybe Any\n   */\n  get(field) {\n    return this.getOwnMeta(field.name)\n               .orElse(_ =>\n                 field.allowInheritance ?  this.getInheritedMeta(field.name)\n                 : /* otherwise */         Maybe.Nothing()\n               ).orElse(_ =>\n                 field.allowPropagation ?  field.merge(this.getPropagatedMeta(field.name))\n                 : /* otherwise */         Maybe.Nothing()\n               );\n  },\n\n  /*~\n   * Retrieves metadata with the given name from the interface\'s current context.\n   *\n   * ---\n   * category   : Querying metadata\n   * complexity : O(n), `n` is the number of objects inside the current context\n   *\n   * type: |\n   *   Interface.(String) => Maybe Any\n   */\n  getByName(name) {\n    return this.get(this.fields.Field.refine({ name }));\n  },\n\n\n  // ---[ Updating Metadata ]------------------------------------------\n\n  /*~\n   * Updates a single metadata field associated with the current interface\'s\n   * context.\n   *\n   * ::\n   *     const a     = Object.freeze({});\n   *     const aMeta = Interface.for(a);\n   *\n   *     aMeta.get(\'name\').getOrElse(\'Anonymous\');  // ==> \'Anonymous\'\n   *\n   *     aMeta.set(\'name\', \'a\');   // ==> aMeta\n   *     aMeta.get(\'name\').get();  // ==> \'a\'\n   *\n   * This operation associates new metadata with the current interface\'s context.\n   * Metadata is attached by using the internal `WeakMap`, and as such can be\n   * used for frozen objects as well.\n   *\n   * > | **NOTE**\n   * > | Since this relies on a global `WeakMap`, it\'s subject to the\n   * > | limitations described in the `Interface`.\n   *\n   * ---\n   * category: Querying and updating metadata\n   *\n   * seeAlso:\n   *   - type: entity\n   *     path: .update\n   *     reason: Convenience for updating multiple metadata fields\n   *\n   * type: |\n   *   (a is Interface).(String, Any) => Interface :: mutates a\n   */\n  set(field, value) {\n    const object = this.object;\n    let meta     = metadata.get(object) || {};\n\n    meta[field] = value;\n    metadata.set(object, meta);\n\n    return this;\n  },\n\n\n  /*~\n   * Updates many metadata fields associated with the current interface\'s\n   * context.\n   *\n   * ::\n   *     const a     = Object.freeze({});\n   *     const aMeta = Interface.for(a);\n   *\n   *     aMeta.get(\'type\').getOrElse(\'Unknown\'); // ==> \'Unknown\'\n   *\n   *     aMeta.update({ name: \'a\', type: \'Object\' }); // ==> aMeta\n   *     aMeta.get(\'name\').get();  // ==> \'a\'\n   *     aMeta.get(\'type\').get();  // ==> \'Object\'\n   *\n   * This operation associates new metadata with the current interface\'s context.\n   * Metadata is attached by using the internal `WeakMap`, and as such can be\n   * used for frozen objects as well.\n   *\n   * > | **NOTE**\n   * > | Since this relies on a global `WeakMap`, it\'s subject to the\n   * > | limitations described in the `Interface`.\n   *\n   * ---\n   * category: Querying and updating metadata\n   *\n   * type: |\n   *   (a is Interface).(String, Object Any) => Interface :: mutates a\n   */\n  update(meta) {\n    keys(meta).forEach(key => this.set(key, meta[key]));\n  },\n\n\n  // ---[ Navigating the context ]-------------------------------------\n\n  /*~\n   * Returns an interface pointing to the given property of the current\n   * context.\n   *\n   * ::\n   *      Interface.property(\'get\').get().object;\n   *      // ==> Interface.get\n   *\n   * ---\n   * category: Navigating the context\n   * type: |\n   *   Interface.(String) => Maybe Interface\n   */\n  property(name) {\n    return name in this.object ?  Maybe.Just(this.for(this.object[name]))\n    :      /* otherwise */        Maybe.Nothing();\n  },\n\n\n  /*~\n   * Returns an interface pointing to a getter with the given name in the\n   * current context.\n   *\n   * ::\n   *     const x = { get value() { } };\n   *     const valueGetter = Object.getOwnPropertyDescriptor(x, \'value\').get;\n   *     Interface.for(x).getter(\'value\').get().object;\n   *     // ==> valueGetter\n   *\n   * ---\n   * category: Navigating the context\n   * type: |\n   *   Interface.(String) => Maybe Interface\n   */\n  getter(name) {\n    return getGetterSetter(this.object, name, \'get\').map(x => this.for(x));\n  },\n\n\n  /*~\n   * Returns an interface pointing to a setter with the given name in the\n   * current context.\n   *\n   * ::\n   *     const x = { set value(arg){ } };\n   *     const valueSetter = Object.getOwnPropertyDescriptor(x, \'value\').set;\n   *     Interface.for(x).setter(\'value\').get().object;\n   *     // ==> valueSetter\n   *\n   * ---\n   * category: Navigating the context\n   * type: |\n   *   Interface.(String) => Maybe Interface\n   */\n  setter(name) {\n    return getGetterSetter(this.object, name, \'set\').map(x => this.for(x));\n  },\n\n\n  /*~\n   * Returns an interface pointing to the prototype of the current context\'s\n   * `[[Prototype]]`.\n   *\n   * ::\n   *     const x = {};\n   *     const y = Object.create(x);\n   *     Interface.for(y).prototype().get().object;\n   *     // ==> x\n   *\n   * ---\n   * category: Navigating the context\n   * type: |\n   *   Interface.() => Maybe Interface\n   */\n  prototype() {\n    const parent = prototypeOf(this.object);\n    return parent != null ?  Maybe.Just(this.for(parent))\n    :      /* otherwise */   Maybe.Nothing();\n  },\n\n\n  // ---[ Additional reflective methods ]------------------------------\n\n  /*~\n   * Retrieves a categorised list of properties owned by the current\n   * context.\n   *\n   * ---\n   * category: Additional reflective methods\n   * type: |\n   *   type PropertyKind is \'value\' or \'getter\' or \'setter\'\n   *   type Property     is { name: String, value: Any, kind: PropertyKind }\n   *\n   *   Interface.() => Array { category: String, members: Array Property }\n   */\n  properties() {\n    return categoriseProperties(this, entriesOf(this.object));\n  },\n\n  /*~\n   * Retrieves a categorised list of properties in the current\n   * context.\n   *\n   * ---\n   * category: Additional reflective methods\n   * type: |\n   *   type PropertyKind is \'value\' or \'getter\' or \'setter\'\n   *   type Property     is { name: String, value: Any, kind: PropertyKind }\n   *\n   *   Interface.() => Array { category: String, members: Array Property }\n   */\n  allProperties() {\n    return categoriseProperties(this, allEntriesOf(this.object));\n  }\n})',
  'location': {
    'filename': 'packages/interface/src/index.js',
    'start': {
      'line': 508,
      'column': 0
    },
    'end': {
      'line': 961,
      'column': 3
    }
  },
  'module': 'metamagical-interface',
  'homepage': 'https://github.com/origamitower/metamagical#readme',
  'licence': 'MIT',
  'authors': ['Quildreen Motta <queen@robotlolita.me>'],
  'repository': 'git://github.com/origamitower/metamagical.git',
  'npmPackage': 'metamagical-interface',
  'copyright': '(c) 2016 Quildreen Motta',
  'maintainers': ['Quildreen Motta <queen@robotlolita.me> (http://robotlolita.me/)'],
  'stability': 'experimental',
  'category': 'Metadata',
  'isModule': true,
  'platforms': ['ECMAScript 2015'],
  'documentation': '\nThe Meta:Magical interface allows one to query meta-data associated\nwith a particular object, or attach new meta-data to any object\nwithout modifying the object.\n\n\n## Why?\n\nLanguages like Python, Ruby, Clojure, Smalltalk, and others support\ninteractively exploring their world of objects. For example, in\nPython, one is able to look at the documentation of an object through\nthe `__doc__` property. In Smalltalk, the platform\'s browser tells\nyou what classes you have, which methods are available on them, their\nsource code, documentation, all in a searchable interactive\nenvironment.\n\nJavaScript has a very limited support for this kind of reflective\ncapabilities. One may, for example, ask which properties an object\nhas, what\'s the name of a function, or its source, but there isn\'t\nmuch beyond that which we could benefit from while exploring a\nparticular library in the REPL. There\'s nothing in JavaScript that\nreifies a concept of documentation, making it accessible at runtime.\n\nIn order to support a more exploration-driven interactive development\nof applications, and even more accurate documentation in more static\nforms (given that JavaScript is too dynamic to lend itself well to\nstatic analysis documentation tools usually rely on), Meta:Magical\nallows people to attach new, arbitrary meta-data to any object in the\nsystem, and query that meta-data later.\n\nThe Meta:Magical project is heavily influenced by work on Smalltalk\nreflective environments, and Clojure\'s take on meta annotations for\nruntime values, and this interface aims to be the basis of better\ntooling for discoverable interactive environments and documentation\ntools.\n\n\n## How Meta:Magical handles metadata?\n\nJavaScript has a prototype-based object-orientation model, which\nbasically means that each object defines its own layout (the methods,\nproperties, fields, etc. it has), rather than linking to a class that\ndefines such. Alongside the possibility of adding or modifying\nproperties in an object at any time, and the new `Symbol` feature,\nthis allows us to attach arbitrary meta-data to any object without\nrisking conflicts.\n\nThere are two ways in which Meta:Magical supports attaching meta-data\nto an object:\n\n  - By assigning an object to the global Meta:Magical symbol:\n\n        object[Symbol.for(\'@@meta:magical\')] = { ... };\n\n  - By using the Interface\'s `.set()` method, which assigns meta-data\n    to an object using an internal `WeakMap` to avoid problems\n    modifying non-owned objects, specially those that have been\n    frozen:\n\n        const frozen = Object.freeze({});\n        Interface.for(frozen).set(\'name\', \'frozen\');\n\nMeta-data associated with an object through the `WeakMap` has\nprecedence over meta-data attached directly on the object, as a\nproperty. This allows people to refine existing meta-data and provide\nnew ones for objects from the outside.\n\n\n## Querying meta-data\n\nThe Meta:Magical interface is an object that wraps another object,\nand lets you reflect over meta-properties associated with that\nobject, by both querying or updating them.\n\nThe `object` method defines which object this interface is looking\nat. By default, the interface starts looking at itself, but it can be\nrefined to look at another object, which can be done by inheriting\nfrom it explicitly or just using the `.for()` method:\n\n    Interface.getByName(\'name\');\n    // ==> \'Interface\'\n\n    const getInterface = Interface.for(Interface.getByName);\n    getInterface.getByName(\'name\');\n    // ==> \'getByName\'\n\n    const myInterface = getInterface.for(Interface);\n    myInterface.getByName(\'name\');\n    // ==> \'Interface\'\n\nAt any point you can use the `object` method to retrieve the\nobject the interface is looking at:\n\n    Interface.object\n    // ==> Interface\n\n\n### Containership and Inheritance\n\nObjects form hierarchies of data, but given a JavaScript object\none is only able to ask which objects are under that, it\'s not\npossible to query which objects contains a particular value.\nThis makes interactive exploration in a REPL harder, because\nwe can\'t figure out the context of a particular value (where\ndoes this belong to?).\n\nTo solve this, Meta:Magical introduces a special piece of metadata,\n`belongsTo`, which lazily provides the missing link:\n\n    const root = {\n      child: { }\n    };\n    root.child[Symbol.for(\'@@meta:magical\')] = {\n      belongsTo() { return root },\n      name: \'child\'\n    };\n\nThis allows one to retrieve which object canonically holds the\ndefinition of a particular value. So, if one has a function like\n`get`, they can retrieve the broader context in which this function\nlives:\n\n    const getMeta = Interface.forObject(Interface.get);\n    getMeta.getByName(\'belongsTo\').getOrElse(null)();\n    // ==> Interface\n\nInternally, Meta:Magical uses this information to propagate some\nmetadata from the broader context (parent object) to the current\ncontext. Things such as `licence`, `repository`, `copyright`, and\nothers allow this kind of inheritance:\n\n    root[Symbol.for(\'@@meta:magical\')] = {\n      licence: \'CC0\'\n    };\n\n    Interface.for(root.child).getInherited(\'licence\').getOrElse(null);\n    // ==> \'CCO\'\n\n\n### Propagation\n\nAnother aspect that\'s important when you have a hierarchy of objects\nis that objects are made out of several smaller pieces. And these\npieces impact the metadata about the top objects. For example, if\na module contains a single experimental function, then it might make\nsense to mark the module as experimental.\n\nMeta:Magical supports this through the concept of propagation. Given\na root object, and a metadata field, one may retrieve all of the\nvalues for that field in all objects contained in it. The interface\nhandles all of the recursion and cycles for you:\n\n    const root = {\n      childA: {\n        childB: { }\n      }\n    };\n    root.childA[Symbol.for(\'@@meta:magical\')] = {\n      stability: \'experimental\'\n    };\n    root.childB[Symbol.for(\'@@meta:magical\')] = {\n      stability: \'stable\'\n    };\n\n    Interface.for(root).getPropagatedMeta(\'stability\');\n    // ==> [\'experimental\', \'stable\']\n\n\n### Simplifying querying with fields\n\nBecause different pieces of metadata have different behaviours\nwith inheritance and propagation, and because propagated metadata\nneeds to be merged for it to make sense (an array of stability\nindexes is often meaningless, for example), Meta:Magical has a\nconcept of fields.\n\n`Field`s are an object that describe how a particular metadata\nis handled, providing a name, inheritance and propagation\nbehaviours, and a way to merge metadata. All of this is used\nby the `.get()` method to provide a value for the metadata.\n\nTaking the example in the previous section, a field could\nprovide an overall stability for the whole module:\n\n    const root = {\n      childA: {\n        childB: { }\n      }\n    };\n    root.childA[Symbol.for(\'@@meta:magical\')] = {\n      stability: \'experimental\'\n    };\n    root.childB[Symbol.for(\'@@meta:magical\')] = {\n      stability: \'stable\'\n    };\n\n    const stability = Interface.fields.stability;\n    Interface.for(root).get(stability).getOrElse(null);\n    // ==> \'experimental\'\n\n    Interface.for(root.childA.childB).get(stability).getOrElse(null);\n    // ==> \'stable\'\n\nFor more information on fields, see the `.fields` property\nexposed by the interface.\n\n\n## Updating meta-data\n\nThe interface object also handles updating meta-data. The newly\nassociated meta-data is stored in a `WeakMap`, rather than on the\nobject itself, to avoid problems with modifying unowned, and frozen\nobjects.\n\nIn order to associate new metadata one needs to construct an\n`Interface` pointing to the object one wants to associate metadata\nwith, and then use the `.set(name, value)` to update the metadata:\n\n    const x = {};\n    const xMeta = Interface.for(x);\n    xMeta.set(\'name\', \'x\');\n    xMeta.getByName(\'name\'); // ==> \'x\'\n\nMultiple metadata may be provided as an object through the\n`.update(meta)` method. All own enumerable key/value pairs provided\nwill replace the existing metadata on the object:\n\n    xMeta.update({ name: \'X\' });\n    xMeta.getByName(\'name\'); // ==> \'X\'\n\n\n## Known issues with Meta:Magical\n\nMeta:Magical\'s use of global symbols for associating meta-data with\nthe objects doesn\'t have any issues, although in the unlikely event\nthat someone uses a global symbol with the `"@@meta:magical"` key\nthat would conflict with this library\'s use of the symbol. As long as\nyou only use the Symbol approach, there are no problems to worry\nabout.\n\nThe use of a `WeakMap` to keep track of additional metadata for\nunowned objects, on the other hand, is somewhat of a problem due to\nJavaScript\'s semantics:\n\n  - The `metamagical-interface` library should be loaded only once.\n    Because the library relies on a single `WeakMap` to keep track\n    of additional metadata, having different libraries (and\n    consequently different state) would lead to inconsistencies and\n    unpredictable behaviour.\n\n  - All code realms should share the same instance of the\n    `metamagical-interface`. Because a JavaScript VM may have\n    different Code Realms (essentially, global execution contexts),\n    it\'s important that all of them share the same Interface\n    instance, otherwise metadata attached in one realm would not be\n    visible in another.\n\n  - The `metamagical-interface` module uses reference equality, so it\n    will treat objects from different realms as different objects, as\n    it will treat duplicated isntances of a particular module (as\n    could happen in npm) as different objects. There is no way of\n    avoiding this problem.\n\nTo ensure that one only has a single instance of the\n`metamagical-interface` module in their application, all modules that\ndepend on this interface should be parameterised and expect an\noutsider to provide the proper object, rather than require it\ndirectly. In essence, modules that depend on the\n`metamagical-interface` should be written as:\n\n    module.exports = function(metamagical) {\n      return {\n        foo() { return metamagical.get(\'name\') }\n      };\n    }\n\nRather than:\n\n    const metamagical = require(\'metamagical-interface\');\n    module.exports = {\n      foo() { return metamagical.get(\'name\') }\n    }\n',
  'examples': [{
    'name': '',
    'call': __metamagical_withMeta(function () {
      Interface.getByName('name'); // ==> 'Interface'
      var getInterface = Interface.for(Interface.getByName);getInterface.getByName('name'); // ==> 'getByName'
      var myInterface = getInterface.for(Interface);myInterface.getByName('name');
    }, {
      'source': 'Interface.getByName(\'name\');\n// ==> \'Interface\'\n\nconst getInterface = Interface.for(Interface.getByName);\ngetInterface.getByName(\'name\');\n// ==> \'getByName\'\n\nconst myInterface = getInterface.for(Interface);\nmyInterface.getByName(\'name\');\n// ==> \'Interface\''
    }),
    'inferred': true
  }, {
    'name': '',
    'call': __metamagical_withMeta(function () {
      var root = { child: {} };root.child[Symbol.for('@@meta:magical')] = {
        belongsTo: function belongsTo() {
          return root;
        },
        name: 'child' };
    }, {
      'source': 'const root = {\n  child: { }\n};\nroot.child[Symbol.for(\'@@meta:magical\')] = {\n  belongsTo() { return root },\n  name: \'child\'\n};'
    }),
    'inferred': true
  }, {
    'name': '',
    'call': __metamagical_withMeta(function () {
      var getMeta = Interface.forObject(Interface.get);getMeta.getByName('belongsTo').getOrElse(null)(); // ==> Interface
    }, {
      'source': 'const getMeta = Interface.forObject(Interface.get);\ngetMeta.getByName(\'belongsTo\').getOrElse(null)();\n// ==> Interface'
    }),
    'inferred': true
  }, {
    'name': '',
    'call': __metamagical_withMeta(function () {
      root[Symbol.for('@@meta:magical')] = { licence: 'CC0' };Interface.for(root.child).getInherited('licence').getOrElse(null); // ==> 'CCO'
    }, {
      'source': 'root[Symbol.for(\'@@meta:magical\')] = {\n  licence: \'CC0\'\n};\n\nInterface.for(root.child).getInherited(\'licence\').getOrElse(null);\n// ==> \'CCO\''
    }),
    'inferred': true
  }, {
    'name': '',
    'call': __metamagical_withMeta(function () {
      var root = { childA: { childB: {} } };root.childA[Symbol.for('@@meta:magical')] = { stability: 'experimental' };root.childB[Symbol.for('@@meta:magical')] = { stability: 'stable' };Interface.for(root).getPropagatedMeta('stability'); // ==> ['experimental', 'stable']
    }, {
      'source': 'const root = {\n  childA: {\n    childB: { }\n  }\n};\nroot.childA[Symbol.for(\'@@meta:magical\')] = {\n  stability: \'experimental\'\n};\nroot.childB[Symbol.for(\'@@meta:magical\')] = {\n  stability: \'stable\'\n};\n\nInterface.for(root).getPropagatedMeta(\'stability\');\n// ==> [\'experimental\', \'stable\']'
    }),
    'inferred': true
  }, {
    'name': '',
    'call': __metamagical_withMeta(function () {
      var root = { childA: { childB: {} } };root.childA[Symbol.for('@@meta:magical')] = { stability: 'experimental' };root.childB[Symbol.for('@@meta:magical')] = { stability: 'stable' };var stability = Interface.fields.stability;Interface.for(root).get(stability).getOrElse(null); // ==> 'experimental'
      Interface.for(root.childA.childB).get(stability).getOrElse(null); // ==> 'stable'
    }, {
      'source': 'const root = {\n  childA: {\n    childB: { }\n  }\n};\nroot.childA[Symbol.for(\'@@meta:magical\')] = {\n  stability: \'experimental\'\n};\nroot.childB[Symbol.for(\'@@meta:magical\')] = {\n  stability: \'stable\'\n};\n\nconst stability = Interface.fields.stability;\nInterface.for(root).get(stability).getOrElse(null);\n// ==> \'experimental\'\n\nInterface.for(root.childA.childB).get(stability).getOrElse(null);\n// ==> \'stable\''
    }),
    'inferred': true
  }, {
    'name': '',
    'call': __metamagical_withMeta(function () {
      var x = {};var xMeta = Interface.for(x);xMeta.set('name', 'x');xMeta.getByName('name'); // ==> 'x'
    }, {
      'source': 'const x = {};\nconst xMeta = Interface.for(x);\nxMeta.set(\'name\', \'x\');\nxMeta.getByName(\'name\'); // ==> \'x\''
    }),
    'inferred': true
  }, {
    'name': '',
    'call': __metamagical_withMeta(function () {
      xMeta.update({ name: 'X' });xMeta.getByName('name'); // ==> 'X'
    }, {
      'source': 'xMeta.update({ name: \'X\' });\nxMeta.getByName(\'name\'); // ==> \'X\''
    }),
    'inferred': true
  }]
});

// --[ Exports ]-------------------------------------------------------
module.exports = Interface;